<?php
namespace Teknisa\CADEST\Services;


use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class GrupoPromocionalService {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
        date_default_timezone_set('America/Sao_Paulo');
    }
    
   public function deleteGrupoPromocional($row){
       $param = array(
                ':CDFILIAL' => null,
                ':CDGRUPROMOC' => $row['CDGRUPROMOC'],
                ':CDPRODPROMOCAO' => $row['CDPRODPROMOCAO'],
                ':NRSEQGRPROMO' => $row['NRSEQGRPROMO'],
                ':NRORG' => $row['NRORG']
           );
        if(array_key_exists('CDFILIAL', $row)){
            $param['CDFILIAL'] =  $row['CDFILIAL'];
            return $this->connection->executeQuery(self::DELETE_GRUPO_PROMO_LOCAL, $param);
        } else {
            return $this->connection->executeQuery(self::DELETE_GRUPO_PROMO_PADRAO, $param);
        }
   }
   
    public function updateImprCupom($CDPRODUTO, $CDFILIAL) {
        $params = array(
            ':CDPRODUTO' => $CDPRODUTO,
            ':CDFILIAL'  => $CDFILIAL
        );
       
        $this->connection->executeQuery(self::UPDATE_GRUPO_PROMO_PADRAO, $params);
        $this->connection->executeQuery(self::UPDATE_GRUPO_PROMO_LOCAL,  $params);
    }
    const UPDATE_GRUPO_PROMO_PADRAO = "
        UPDATE GRUPROMOCPROD
           SET IDIMPGRPROMO = 'N' 
         WHERE CDPRODPROMOCAO = :CDPRODUTO
    ";
        
    const UPDATE_GRUPO_PROMO_LOCAL = "
        UPDATE GRUPROMOCPRFIL
           SET IDIMPGRPROMOFIL = 'N'
         WHERE CDPRODPROMOCAO = :CDPRODUTO 
           AND CDFILIAL = :CDFILIAL
    ";
       
    const DELETE_GRUPO_PROMO_PADRAO = '
         DELETE FROM GRUPROMOCPROD 
          WHERE CDGRUPROMOC = :CDGRUPROMOC 
          AND  NRSEQGRPROMO = :NRSEQGRPROMO
            AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
            AND NRORG = :NRORG';
        
    const DELETE_GRUPO_PROMO_LOCAL = '
    DELETE FROM GRUPROMOCPRFIL 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG
        AND CDFILIAL = :CDFILIAL';
        
    const DELETE_FILHO_PADRAO = '
    DELETE FROM DESGRUPROMOCPR 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND NRSEQGRPROMO = :NRSEQGRPROMO
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG';
    
     const DELETE_FILHO_LOCAL = '
    DELETE FROM DESGRUPROMPRFIL 
        WHERE CDGRUPROMOC = :CDGRUPROMOC 
        AND CDPRODPROMOCAO = :CDPRODPROMOCAO 
        AND NRORG = :NRORG
        AND CDFILIAL = :CDFILIAL';
    
}